SystemOrganization addCategory: #'GT-SpotterExtensions-Core'!

!GTPlayPage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 4/9/2015 11:48'!
spotterActDefault
	| result |
	result := GTPlayground new openOn: self.
	"Spotter only sets the title without installing the stash persistency.
	This is because when openinng the Playground the changing of the text triggers a save and this implies resaving the file under a new name and this is not wanted for the named pages. 
	So, we work around that and we ensure that the stash is created after the playground is created.
	This code has to be revisited."
	self title notNil ifTrue: [ self ensureStashPersistency ].
	^ result! !

!GTPlayPage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:02'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: 'Preview';
		display: #content;
		smalltalkClass: [ nil ];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!Dictionary methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 12/1/2015 19:44'!
spotterForKeysFor: aStep
	<spotterOrder: 15>
	aStep listProcessor
			title: 'Keys';
			allCandidates: [ self keys ];
			candidatesLimit: 5;
			filter: GTFilterSubstring! !

!MCHttpRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:50'!
gtDisplayOn: aStream
	aStream nextPutAll: self location! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:35'!
spotterActDefault
	self value inspect! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterClassFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'Class';
			allCandidates: [ { self value class }];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/12/2016 00:31'!
spotterForReferencesFor: aStep
	<spotterOrder: 130>
	aStep listProcessor
			title: 'References';
			allCandidates: [ (SystemNavigation default allReferencesTo: self) collect: #compiledMethod ];
			itemName: [ :method | method gtDisplayString ];
			filter: GTFilterSubstring! !

!RPackageTag class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExamplePackageTag
	<gtExample>
	<label: 'Tag'>
	
	^ (RPackageOrganizer default packageOf: GTSpotter) classTags anyOne! !

!RPackageTag methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterClassesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ self classes sorted: [ :a :b | a name < b name ] ];
			title: 'Classes';
			filter: GTFilterSubstring! !

!RBProgramNode methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 12/1/2015 17:50'!
gtSpotterCodePreviewIn: aComposite
	<spotterPreview: 10>
	self source ifNil: [ ^ self ].
		
	^ aComposite pharoMethod
			title: 'Source code';
			display: [ self source ];
			smalltalkClass: [ self parents first compilationContext ifNotNil: [ :ctx | ctx getClass ] ];
			selectionInterval: [ self sourceInterval ];
			entity: self! !

Object subclass: #GTSelector
	instanceVariableNames: 'name methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-Core'!

!GTSelector commentStamp: 'TudorGirba 1/11/2016 00:14' prior: 0!
This is a helper class for modeling a selector. We need this in order to support diving in such a selector and to offer specific processors (like implementors or senders) in Spotter .!

!GTSelector class methodsFor: 'examples' stamp: 'TudorGirba 1/10/2016 17:36'!
gtExampleNew
	<gtExample>
	^ self new name: #new! !

!GTSelector class methodsFor: 'private' stamp: 'TudorGirba 3/22/2016 17:38'!
substring: aString filter: aFilter
	| selectors |
	aString isEmptyOrNil ifTrue: [ ^ self ].
	selectors := IdentityDictionary new.
	SystemNavigation default allBehaviorsDo: [ :class | 
		class selectorsAndMethodsDo: [ :selector :method | 
			(selector asString includesSubstring: aString caseSensitive: false) ifTrue: [ 
				| group newGroup | 
				group := selectors 
					at: selector 
					ifAbsentPut: [ aFilter value: (newGroup := GTSelector new name: selector; yourself). newGroup ].
				group addMethod: method ] ] ] ! !

!GTSelector methodsFor: 'private accessing' stamp: 'TudorGirba 3/22/2016 17:39'!
addMethod: aCompiledMethod
	"this is a private method that can be used by the constructor on the class side
	exclusively within the context of Spotter"
	methods ifNil: [ methods := OrderedCollection new ].
	methods add: aCompiledMethod! !

!GTSelector methodsFor: 'printing' stamp: 'TudorGirba 3/22/2016 17:37'!
gtDisplayOn: stream
	stream nextPutAll: self name! !

!GTSelector methodsFor: 'querying' stamp: 'TudorGirba 3/22/2016 17:46'!
implementors
	^ methods ifNil: [ 
		methods := (SystemNavigation default allImplementorsOf: self name) 
			collect: [ :each | each compiledMethod ] ]! !

!GTSelector methodsFor: 'initialization' stamp: 'TudorGirba 3/22/2016 17:38'!
initialize
	super initialize.
	
	methods := nil! !

!GTSelector methodsFor: 'accessing' stamp: 'TudorGirba 3/22/2016 17:37'!
name
	^ name! !

!GTSelector methodsFor: 'accessing' stamp: 'TudorGirba 3/22/2016 17:37'!
name: anObject
	name := anObject! !

!GTSelector methodsFor: 'querying' stamp: 'TudorGirba 1/10/2016 07:49'!
senders
	^ SystemNavigation default allSendersOf: self name! !

!GTSelector methodsFor: 'ui' stamp: 'TudorGirba 3/22/2016 17:42'!
spotterImplementorsFor: aStep
	<spotterOrder: 40>
	^ aStep listProcessor
		title: 'Implementors';
		filter: GTFilterSubstring item: [ :filter :context | self implementors do: filter ];
		keyBinding: $m meta! !

!GTSelector methodsFor: 'ui' stamp: 'TudorGirba 3/22/2016 17:42'!
spotterPreviewIn: aComposite
	<spotterPreview: 10>
	aComposite list
		title: 'Preview';
		display: [ :x | x ];
		format: [ :method | GTSpotterItemBrick new text: method gtDisplayString; disable; yourself ];
		entity: self implementors! !

!GTSelector methodsFor: 'ui' stamp: 'TudorGirba 2/29/2016 16:13'!
spotterSendersFor: aStep
	<spotterOrder: 50>
	^ aStep listProcessor
		title: 'Senders';
		filter: GTFilterSubstring item: [ :filter :context | 
			self senders do: [ :sender | 
				filter value: sender compiledMethod ] ];
		keyBinding: $n meta! !

!Object methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/21/2015 21:56'!
gtInspectorActionSpot
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ 
			GTSpotterMorph new
				extent: 400@500;
				doLayout;
				spotterModel: (GTSpotter on: self);
				openCenteredInWorld
			 ];
		icon: GLMUIThemeExtraIcons glamorousSearch;
		condition: [ 
				| fakeStep |
				fakeStep := GTSpotter new newStep origin: self.
				self spotterProcessorsFor: fakeStep.
				fakeStep processors notEmpty ];
		title: 'Search'! !

Object subclass: #PragmaType
	instanceVariableNames: 'keyword pragmas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-Core'!

!PragmaType commentStamp: 'TudorGirba 11/16/2014 12:57' prior: 0!
This models the type of pragma instances.

It essentially knows the keyword that defines the Pragma, and can obtain all occurences of that Pragma.

!!!!Example

[[[
	PragmaType all
]]]!

!PragmaType class methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:52'!
all
	| pragmas |
	pragmas := OrderedCollection new.
	Object withAllSubclassesDo: [:each |
		Pragma withPragmasIn: each do: [:p |
			pragmas add: p]].
	^ (pragmas groupedBy: #keyword) associations collect: [ :association |
		PragmaType new
			keyword: association key; 
			pragmas: association value ] ! !

!PragmaType class methodsFor: 'examples' stamp: 'StefanReichhart 4/9/2015 12:00'!
gtExampleAnyOne
	<gtExample>
	^ self all anyOne! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/16/2014 12:54'!
gtInspectorPragmasIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Pragmas';
		display: [ self pragmas ];
		format: #gtDisplayString! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 10:07'!
keyword
	^ keyword! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 10:07'!
keyword: anObject
	keyword := anObject! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:58'!
pragmas
	^ pragmas ifNil: [
		pragmas := OrderedCollection new.
		Object withAllSubclassesDo: [ :each |
			Pragma withPragmasIn: each do: [ :p |
				p keyword = self keyword ifTrue: [ 
					pragmas add: p ] ] ].
		pragmas ]! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:52'!
pragmas: aCollection
	pragmas := aCollection! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/16/2014 12:53'!
printOn: stream
	stream nextPutAll: self keyword! !

!PragmaType methodsFor: 'ui' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterPragmasFor: aStep
	<spotterOrder: 40>
	^ aStep listProcessor
		title: 'Pragmas';
		allCandidates: [ self pragmas ];
		itemName: [ :pragma | pragma method printString , ' ' , pragma asString ];
		filter: GTFilterSubstring! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 1/10/2016 08:11'!
spotterPreviewItemsIn: aComposite
	<spotterPreview: 10>
	
	aComposite list
		title: '<', self gtDisplayString, '>';
		display: [ :x | x ];
		format: [ :pragma | GTSpotterItemBrick new text: pragma method gtDisplayString; disable; yourself ];
		entity: self pragmas asArray.! !

!PragmaType methodsFor: 'ui' stamp: 'StefanReichhart 1/10/2016 15:41'!
spotterSendersFor: aStep
	<spotterOrder: 50>
	^ aStep listProcessor
		title: 'Senders';
		filter: GTFilterSubstring item: [ :filter :context | 
			self keyword senders do: [ :sender | 
				filter value: sender compiledMethod ] ]! !

!Bag class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:04'!
gtExampleBagWithOneElement
	<gtExample>
	^ Bag with: 42! !

!Bag class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:03'!
gtExampleBagWithTenElements
	<gtExample>
	^ #(1 2 3 1 2 3 3 4 5 3) asBag! !

!Bag class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:03'!
gtExampleEmptyBag
	<gtExample>
	^ Bag new! !

GTFilterSubstring subclass: #GTFilterFileReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-Core'!

!GTFilterFileReference methodsFor: 'private' stamp: 'TudorGirba 2/26/2016 23:09'!
indexForItemName: aString andQuery: aQueryString
	^ aQueryString isEmpty
		ifTrue: [ 1 ] " if the modified query is empty, take all items -> index = 1 "
		ifFalse: [ super indexForItemName: aString andQuery: aQueryString ]! !

!GTFilterFileReference methodsFor: 'accessing' stamp: 'StefanReichhart 4/1/2015 22:12'!
queryForItem: each
	self flag: 'this is an ugly hack for #queryForFileReference. The iterator will manipulate the query being used for each item'.
	^ self context cacheAt: #queryForFileReference ifAbsent: [ query ] " performance optimization "! !

GTFilterSubstring subclass: #GTFilterImplementor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-Core'!

!GTFilterImplementor class methodsFor: 'public' stamp: 'StefanReichhart 4/1/2015 21:53'!
gtListFilter
	^ GTFilterSubstring new! !

!GTFilterImplementor methodsFor: 'public' stamp: 'StefanReichhart 4/1/2015 21:53'!
gtListFilter
	^ GTFilterSubstring new! !

!GTFilterImplementor methodsFor: 'private-model' stamp: 'StefanReichhart 4/1/2015 22:10'!
itemFilterNameFor: each
	self flag: 'this filter wants to filter items by #selector (speed 10x), but dive-in-category wants to filter by #printString. Most filters in dive-in-category wants to filter by #printString, but not all. Others: files, topics, help, ... ?'.
	^ each selector! !

!Morph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 12/1/2015 16:36'!
spotterForKeysFor: aStep
	<spotterOrder: 15>
	(self hasProperty: #kmDispatcher) ifFalse: [^self].
	self kmDispatcher spotterForKeysFor: aStep! !

!Morph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 12/1/2015 16:40'!
spotterForSubmorphsFor: aStep
	<spotterOrder: 10>
	self submorphs ifNil: [ ^ self ].
	
	aStep listProcessor
			title: 'Submorphs';
			allCandidates: [ self submorphs ];
			candidatesLimit: 5;
			filter: GTFilterSubstring! !

!Morph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 6/22/2015 23:51'!
spotterPreviewMorphIn: aComposite
	<spotterPreview: 20>
	aComposite custom: 
		(self imageForm asAlphaImageMorph asBrick margin: 20)! !

!MetacelloAbstractPackageSpec class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExamplePackageSpec
	<gtExample>
	<label: 'Metacello package reference'>
	
	^ (ConfigurationOfGTSpotter project version: #development) packages anyOne! !

!MetacelloAbstractPackageSpec methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:00'!
spotterForIncludesFor: aStep
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Includes';
		allCandidates: [ self includes ];
		itemName: [ :item | item name ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!MetacelloAbstractPackageSpec methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:00'!
spotterForRequiresFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Requires';
		allCandidates: [ self requires ];
		itemName: [ :item | item name ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 5/7/2015 15:26'!
spotterActDefault
	^ Smalltalk tools browser openOnPackage: self! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterClassesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ self definedClasses sorted: [ :a :b | a name < b name ] ];
			title: 'Classes';
			filter: GTFilterSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterExtensionMethodsFor: aStep
	<spotterOrder: 30>
	aStep listProcessor
			allCandidates: [ self extensionMethods ];
			title: 'Extension Methods';
			filter: GTFilterSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'MarcusDenker 6/8/2016 15:40'!
spotterMonticelloPackageFor: aStep
	<spotterOrder: 41>
	aStep listProcessor
		title: 'Monticello Package';
		allCandidates: [ self mcPackage 
			ifNotNil: [ :mcPackage | Array with: mcPackage ] 
			ifNil: [ #() ] ];
		itemIcon: [ Smalltalk ui icons iconNamed: #monticelloPackageIcon ];
		filter: GTFilterSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'MarcusDenker 6/8/2016 15:40'!
spotterMonticelloWorkingCopyFor: aStep
	<spotterOrder: 42>
	aStep listProcessor
		title: 'Monticello Working Copy';
		allCandidates: [ self mcPackage 
			ifNotNil: [ :mcPackage | Array with: mcPackage workingCopy ] 
			ifNil: [ #() ] ];
		itemIcon: [ Smalltalk ui icons iconNamed: #versionControlIcon ];
		filter: GTFilterSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:01'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite list
		title: 'Preview';
		display: [ :x | x ];
		format: [ :class | GTSpotterItemBrick new text: class gtDisplayString; icon: class systemIcon; disable; yourself ];
		entity: self classes asArray.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:01'!
spotterTagsFor: aStep
	<spotterOrder: 20>
	self classTags size <= 1 ifTrue: [ ^ self ].
	aStep listProcessor
			allCandidates: [ self classTags sorted: [ :a :b | a name < b name ] ];
			title: 'Tags';
			itemName: [ :item | item name ];
			filter: GTFilterSubstring! !

!RBBrowserEnvironment methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 3/23/2015 13:12'!
withClassesFixedForNautilus! !

!MCPackage class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleNoPackage
	<gtExample>
	<label: 'Metacello package without corresponding RPackage'>
	
	^ MCPackage named: 'No-correspondingRPackage-For-This-MCPackage'! !

!MCPackage class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExamplePackage
	<gtExample>
	<label: 'Metacello package with corresponding RPackage'>
	
	MCWorkingCopy allManagers do: [ :each | 
		each packageName = 'GT-SpotterExtensions-Core' ifTrue: [ ^ each package ] ].
	^ nil! !

!MCPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 17:17'!
gtDisplayOn: aStream
	aStream nextPutAll: self name! !

!MCPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterForPackageFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Packages';
		allCandidates: [ Array with: self correspondingRPackage ];
		itemName: [ :package | package name ];
		itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
		filter: GTFilterSubstring! !

!MCPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterMonticelloWorkingCopyFor: aStep
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Monticello Working Copy';
		allCandidates: [ Array with: self workingCopy ];
		itemIcon: [ Smalltalk ui icons iconNamed: #versionControlIcon ];
		filter: GTFilterSubstring! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/2/2015 14:34'!
isZipFile
	^ self isFile and: [ #('zip' 'jar' 'ear' 'war') includes: self extension ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterForDirectoriesFor: aStep
	<spotterOrder: 10>
	^ self isDirectory ifTrue: [
		aStep listProcessor
			allCandidates: [ self directories ];
			title: 'Directories';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousFolder ];
			filter: GTFilterSubstring ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterForFilesFor: aStep
	<spotterOrder: 20>
	^ self isDirectory ifTrue: [
		aStep listProcessor
			allCandidates: [ self files ];
			title: 'Files';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
			filter: GTFilterSubstring ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/2/2015 22:26'!
spotterForZipDirectoriesFor: aStep
	<spotterOrder: 10>
	| zipFileSystem |
	self isZipFile ifFalse: [ ^ self ].
	aStep listProcessor
			allCandidates: [ 
				zipFileSystem := (FileSystem zip: self) open.
				zipFileSystem workingDirectory directories ];
			title: 'Directories';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousFolder ];
			filter: GTFilterSubstring! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterForZipFilesFor: aStep
	<spotterOrder: 10>
	| zipFileSystem |
	self isZipFile ifFalse: [ ^ self ].
	aStep listProcessor
			allCandidates: [ 
				zipFileSystem := (FileSystem zip: self) open.
				zipFileSystem workingDirectory files ];
			title: 'Files';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
			filter: GTFilterSubstring
	! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/9/2015 08:11'!
spotterPreviewContentsIn: aComposite
	<spotterPreview: 20>
	
	self isFile ifFalse: [ ^ self ].
	aComposite text
		title: [ self gtDisplayString ]; 
		display: #yourself;
		entity: (self readStreamDo: [ :stream | 
					| result |
					result := [(stream next: 10000) asString]
						on: Error 
						do: [ (stream binary next: 10000) asString ].
					stream size > 10000
						ifTrue: [ result, '  ... truncated ...' ]
						ifFalse: [ result ] ])! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:00'!
spotterPreviewItemsIn: aComposite
	<spotterPreview: 10>
	
	self isDirectory ifFalse: [ ^ self ].
	aComposite list
		title: [ self gtDisplayString ];
		display: #yourself;
		format: [ :folder | 
			GTSpotterItemBrick new 
				text: folder basename; 
				icon: (folder isDirectory 
								ifTrue: [Smalltalk ui theme icons glamorousFolder]
								ifFalse: [Smalltalk ui theme icons glamorousBrowse] ); 
				disable; 
				yourself ];
		styled: [ :brick | brick ];
		entity: self directories, self files.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:57'!
spotterPreviewPngIn: aComposite
	<spotterPreview: 10>
	
	(self mimeTypes notNil and: [ 
		self mimeTypes first matches: ZnMimeType imagePng ]) 
		ifFalse: [ ^ self ].
	aComposite custom: 
		((self binaryReadStreamDo: [ :stream | PNGReadWriter formFromStream: stream ])
			asAlphaImageMorph asBrick margin: 20)! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/9/2015 08:08'!
spotterPreviewStScriptIn: aComposite
	<spotterPreview: 10>
	
	(self extension = 'st' or: [self extension = 'ph']) 
		ifFalse: [ ^ self ].
	aComposite pharoMethod 
		title: [self gtDisplayString];
		display: #yourself;
		smalltalkClass: [ nil ];
		entity: (self readStreamDo: #contents)! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/11/2015 22:05'!
spotterPreviewZipItemsIn: aComposite
	<spotterPreview: 10>

	| zip |
	self isZipFile ifFalse: [ ^ self ].
	zip:= (FileSystem zip: self) open workingDirectory.
	aComposite list
		title: [ self gtDisplayString ];
		display: #yourself;
		format: [ :folder | 
			GTSpotterItemBrick new 
				text: folder basename; 
				icon: (folder isDirectory 
								ifTrue: [Smalltalk ui theme icons glamorousFolder]
								ifFalse: [Smalltalk ui theme icons glamorousBrowse] ); 
				disable; 
				yourself ];
		styled: [ :brick | brick ];
		entity: (zip directories, zip files)! !

!MenuItemMorph class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:23'!
gtExampleMenuItemMorphWithSubitems
	<gtExample>
	<label: 'Menu item with subitems'>
	
	^ World worldMenu items 
		detect: [ :each | each contents = 'System' ]! !

!MenuItemMorph class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:23'!
gtExampleMenuItemMorphWithoutSubitems
	<gtExample>
	<label: 'Menu item without subitems'>
	
	^ World worldMenu items 
		detect: [ :each | each contents = 'System Browser' ]! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/21/2014 11:13'!
spotterActDefault
	self doButtonAction! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 12:21'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	self hasSubMenu ifTrue: [ 
		self subMenu spotterItemsFor: aStep ]! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 1/29/2015 03:21'!
spotterPreviewMenuIn: aComposite
	<spotterPreview: 10>
	
	aComposite list
		title: [ self contents ];
		display: #yourself;
		format: [ :item | 
			GTSpotterItemBrick new 
				text: item contents; 
				icon: item icon; 
				disable;
				yourself ];
		styled: [ :brick | brick ];
		entity: (self hasSubMenu ifFalse: [ {self} ] ifTrue: [ self subMenu allItems ]).
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!RBVariableEnvironment methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 3/23/2015 13:11'!
withClassesFixedForNautilus
	instanceVariables ifEmpty: [ 
		classVariables keysAndValuesDo: [ :class :variables | 
			instanceVariables at: class ifAbsentPut: [ Set new ] ] ].
! !

!Slot methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 7/8/2015 14:44'!
spotterAccessesFor: aStep
	<spotterOrder: 10>
	(aStep hasPreviousStep and: [
		(aStep previousStep origin isKindOf: Class) or: [
			aStep origin isKindOf: Class]]) ifTrue: [
		aStep listProcessor
				title: 'Accesses';
				allCandidates: [ 
					SystemNavigation default 
						allAccessesTo: self name 
						from: aStep previousStep origin ];
				itemName: [:each | each asString];
				filter: GTFilterSubstring ]! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/23/2015 14:12'!
spotterClassInstanceVariablesFor: aStep
	<spotterOrder: 25>
	self isTrait ifTrue: [ ^ self ].
	aStep listProcessor
			title: 'Class instance variables';
			allCandidates: [ self class layout allSlots ];
			itemName: [:each | each name asString];
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterCompositionFor: aStep
	<spotterOrder: 25>
	aStep listProcessor
			title: 'Composing traits';
			allCandidates: [ self traitComposition allTraits ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/23/2015 14:12'!
spotterInstanceVariablesFor: aStep
	<spotterOrder: 20>
	self isTrait ifTrue: [ ^ self ].
	aStep listProcessor
			title: 'Instance variables';
			allCandidates: [ self layout allSlots ];
			itemName: [:each | each name asString];
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterSubclassesFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'All subclasses';
			allCandidates: [ self allSubclasses ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterSuperclassesFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
			title: 'All superclasses';
			allCandidates: [ self allSuperclasses ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/26/2015 17:26'!
spotterTraitUsersFor: aStep
	<spotterOrder: 20>
	self isTrait ifFalse: [ ^ self ].
	aStep listProcessor
			title: 'Users';
			allCandidates: [ self traitUsers asArray ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:06'!
spotterUsedSlotsFor: aStep
	<spotterOrder: 70>
	aStep listProcessor
			title: 'Special Slots';
			allCandidates: [ self slots select: [ :slot | slot isSpecial ] ];
			itemName: [ :item | item definitionString ];
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterUsedTraitsFor: aStep
	<spotterOrder: 60>
	aStep listProcessor
			title: 'Uses Traits';
			allCandidates: [ self traits asArray ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 1/11/2016 19:16'!
withMethodSender: aLiteral do: aBlock
	| special byte |
	special := Smalltalk hasSpecialSelector: aLiteral ifTrueSetByte: [ :value | byte := value ].
	self selectorsAndMethodsDo: [ :selector :method | 
		((method hasLiteral: aLiteral) 
			or: [ (method refersToLiteral: aLiteral) 
				or: [ special and: [ method scanFor: byte ] ] ])
					ifTrue: [ aBlock value: method ] ].! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 1/11/2016 07:34'!
withMethodsReferTo: aLiteral do: aBlock
	| special byte |
	special := Smalltalk hasSpecialSelector: aLiteral ifTrueSetByte: [ :value | byte := value ].
	self selectorsAndMethodsDo: [ :selector :method | 
		((method hasLiteral: aLiteral) 
			or: [ special and: [ method scanFor: byte ] ])
				ifTrue: [ aBlock value: method ] ]! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 1/11/2016 07:34'!
withThorougMethodsReferTo: aLiteral do: aBlock
	| special byte |
	special := Smalltalk hasSpecialSelector: aLiteral ifTrueSetByte: [ :value | byte := value ].
	self selectorsAndMethodsDo: [ :selector :method |
		((method refersToLiteral: aLiteral) 
			or: [ special and: [ method scanFor: byte ] ]) 
				ifTrue: [ aBlock value: method ] ]! !

!MetacelloVersion class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:20'!
gtExampleMetacelloVersion
	<gtExample>
	<label: 'Metacello Version'>
	
	^ ConfigurationOfGTSpotter project version: #development! !

!MetacelloVersion methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:00'!
spotterForGroupsFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Groups';
		allCandidates: [ self groups ];
		itemName: [ :item | item name ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!MetacelloVersion methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:00'!
spotterForPackagesFor: aStep
	<spotterOrder: 3>
	aStep listProcessor
		title: 'Packages';
		allCandidates: [ self packages ];
		itemName: [ :item | item file ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!MCDirectoryRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:51'!
gtDisplayOn: aStream
	aStream nextPutAll: self description! !

!KMKeymap methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 12/1/2015 17:49'!
gtSpotterCodePreviewIn: aComposite
	<spotterPreview: 10>

	^ self action gtSpotterCodePreviewIn: aComposite! !

!ClassDescription class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/26/2015 17:17'!
gtExampleRPackage
	<gtExample>
	^ GTSpotter package! !

!MCRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:53'!
gtDisplayOn: aStream
	aStream nextPutAll: self description! !

!TClassDescription methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:01'!
spotterPackageFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'Package';
			allCandidates: [ {self package} ];
			itemName: [ :item | item packageName ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!GTSpotter class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 7/10/2015 15:33'!
spotterExtensionsFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			allCandidates: [ self spotterExtendingMethods ];
			title: 'Extensions';
			itemName:[ :each | each gtDisplayString ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: true! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'TudorGirba 4/11/2015 22:57'!
concreteMethodsInContext: aContext usingFilter: aFilter
	" return the concrete methods described by the expression (Class >> #Selector) - evaluate it savely "
	| classAndSelectorStrings class selector |
	classAndSelectorStrings := (aContext textTrimmed splitOn: '>>') collect: [ :each | each trimBoth ].
	
	" check preconditions "
	classAndSelectorStrings size = 2 ifFalse: [ ^ self ].
	classAndSelectorStrings second size < 2 ifTrue: [ ^ self ].

	" retrieve concrete class and selector - or saerch all behaviors "
	selector := classAndSelectorStrings second first = $# 
		ifTrue: [ classAndSelectorStrings second allButFirst asSymbol ]
		ifFalse: [ classAndSelectorStrings second asSymbol ].
	
	(class := Smalltalk classNamed: classAndSelectorStrings first) ifNil: [ 
		SystemNavigation default allBehaviorsDo: [ :aClass |
			aClass methodsDo: [ :method |
				method selector = selector ifTrue: [ aFilter value: method ] ] ].
		^ self ].
	
	
	" retrieve the compiled method in the class and class hierarchy "
	class withAllSuperclassesDo: [ :aClass |
		aFilter value: ([ aClass compiledMethodAt: selector ] on: Error do: [ ^ self ]) ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 3/23/2015 16:35'!
evaluateExpressionInContext: aSpotterContext usingFilter: filter
	" only allow arithmethic selectors to be evaluated - otherwise this may have some severe side-effects "
	| result |
	" filter allowed selectors "
	(Number withAllSubclasses anySatisfy: [ :class |
		class selectors anySatisfy: [ :selector | 
			aSpotterContext textTrimmed includesSubstring: selector caseSensitive: true ] ]) ifFalse: [ ^ self ].
	" perform the selector "
	Smalltalk compiler 
		silentlyDo: [ result := Smalltalk compiler evaluate: aSpotterContext textTrimmed ] 
		exceptionDo: [ ^ self ].
	result isNumber ifFalse: [ ^ self ].
	filter value: result. 
	" if the result is not readable as float, append the float as well "
	(result isFraction and: [ result isInteger not ]) ifTrue: [
		filter value: result asFloat ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 4/1/2015 22:12'!
fileReferencesBy: aSelector inContext: aSpotterContext usingFilter: aBlock
	| split rootDirectory query |
	split := aSpotterContext textLowercase piecesCutWhere: [ :a :b | a = FileSystem disk delimiter ].
	split size < 1
		ifTrue: [ 
			query := aSpotterContext textLowercase.
			rootDirectory := FileSystem workingDirectory ]
		ifFalse: [ 
			(split last last = FileSystem disk delimiter)
				ifTrue: [ 
					query := ''.
					rootDirectory := aSpotterContext textLowercase asFileReference ]
				ifFalse: [ 
					query := split last.
					rootDirectory := ('' join: split allButLast) asFileReference ] ].
	rootDirectory exists ifFalse: [ ^ self ].
	self flag: 'this is an ugly hack for #queryForFileReference. This iterator has to manipulate the query in order for the filter to work properly'.
	aSpotterContext cacheAt: #queryForFileReference put: query.
	(rootDirectory perform: aSelector) do: aBlock! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/28/2016 11:50'!
gtSpotterExamplesFor: aStep
	<todo: 'example streaming to speed up spotter!!!!!!'>
	<spotterOrder: 41>
	aStep listProcessor
		title: 'Examples';
		allCandidates: [ GTExampleFinder allGTExamples ];
		itemName: [ :example | String streamContents: [:s | example gtDisplaySummaryOn: s] ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 3/22/2016 23:20'!
spotterClipboardFor: aStep
	<spotterOrder: 90>
	^ aStep listProcessor
		title: 'Clipboard History';
		items: [ Clipboard default recentItems ];
		itemName: [ :item | item asString contractTo: 100 ];
		itemFilterName: [ :item | item asString ];
		filter: GTFilterSubstrings;
		actLogic: [ :item :step |
			step exit.
			item asString inspect ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 4/1/2015 22:13'!
spotterConcreteMethodFor: aStep
    <spotterOrder: 30>
	self flag: #specialFilter.
	^ aStep listProcessor
		title: 'Methods';
		filter: GTNullFilter item: [ :filter :context |
			self concreteMethodsInContext: context usingFilter: filter ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterDirtyMonticelloPackagesFor: aStep
	<spotterOrder: 85>
	aStep listProcessor
			allCandidates: [ MCWorkingCopy allManagers select: #modified ];
			title: 'Dirty Monticello packages';
			itemIcon: [ Smalltalk ui icons iconNamed: #dirtyPackageIcon ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: true! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 4/7/2015 23:32'!
spotterForCachedPlaygroundPagesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
			allCandidates: [ GTPlayBook instance pages ];
			title: 'Playground cached pages';
			itemName: [ :page | page content asString contractTo: 100 ];
			filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/19/2016 17:49'!
spotterForClassesFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			allCandidates: [ Smalltalk allClassesAndTraits ];
			title: 'Classes';
			filter: GTFilterSubstring;
			itemIcon: #systemIcon;
			keyBinding: $b meta;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:44'!
spotterForDirectoriesFor: aStep
	<spotterOrder: 50>
	self flag: #specialFilter.
	aStep listProcessor
		title: 'Directories';
		itemIcon: [ GLMUIThemeExtraIcons glamorousFolder ];
		itemFilterName: [ :reference | reference basename ];
		filter: GTFilterFileReference item: [ :filter :context | 
			self fileReferencesBy: #directories inContext: context usingFilter: filter ];
		wantsToDisplayOnEmptyQuery: false	! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:42'!
spotterForExpressionsFor: aStep
	<spotterOrder: 1>
	self flag: #specialFilter.
	aStep listProcessor
		title: 'Calculator';
		filter: GTNullFilter item: [ :filter :context | 
			self evaluateExpressionInContext: context usingFilter: filter ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:45'!
spotterForFilesFor: aStep
	<spotterOrder: 40>
	self flag: #specialFilter.
	aStep listProcessor
		title: 'Files';
		itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
		itemFilterName: [ :reference | reference basename ];
		filter: GTFilterFileReference item: [ :filter :context | 
			self fileReferencesBy: #files inContext: context usingFilter: filter ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterForGlobalVarsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
			allCandidates: [ Smalltalk globals associations select:[:assoc | 
			assoc value isBehavior not and:[ 
				assoc value isTrait not]] ];
			title: 'Global variables';
			itemName:[:global | global key ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 14:40'!
spotterForHelpTopicFor: aStep
	<spotterOrder: 200>
	aStep listProcessor 
			allCandidates: [ SystemHelp asHelpTopic gtAllSubtopics ];
			title: 'Help topics';
			itemName: [ :helpTopic | helpTopic title ];
			itemIcon: [ :helpTopic | helpTopic gtTopicIcon ];
			matchSubstrings;
			wantsToDisplayOnEmptyQuery: true! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 3/22/2016 23:21'!
spotterForMessagesFor: aStep
	<spotterOrder: 35>

	aStep listProcessor
		title: 'Messages';
		filter: GTNullFilter item: [ :filter :context | 
			GTSelector substring: context textTrimmed filter: filter ];
		actLogic: [ :each :step|
			step exit.
			self systemNavigation browseAllImplementorsOf: each name ];		
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'VincentBlondeau 4/13/2016 10:29'!
spotterForMetacelloConfigurationsFor: aStep
	<spotterOrder: 86>
	aStep listProcessor
			title: 'Metacello Configurations';
			allCandidates: [ 
				Smalltalk allClasses select: [ :each | 
					(each respondsTo: #isMetacelloConfig) 
						and: [ each isMetacelloConfig
							and: [ each name beginsWith: 'ConfigurationOf' ] ] ]
					thenCollect: #project ];
			itemName: [ :each | each configuration class name ];
			itemIcon: [ Smalltalk ui icons iconNamed: #config ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterForPackagesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ RPackageOrganizer default packages ];
			title: 'Packages';
			itemName: [ :package | package name ];
			itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/8/2015 14:13'!
spotterForPragmasFor: aStep
	<spotterOrder: 40>
	aStep listProcessor 
			allCandidates: [ PragmaType all ];
			title: 'Pragmas';
			itemName: [ :pragma | pragma keyword ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/19/2016 22:40'!
spotterForReferencesFor: aStep
	<spotterOrder: 32>
	
	aStep listProcessor
		title: 'References';
		filter: GTNullFilter item: [ :filter :context | 
			context textTrimmed asClassIfPresent: [ :class |
				SystemNavigation default allReferencesTo: class binding do: filter ] ];
		keyBinding: $n shift meta;
		itemName: [ :method | method gtDisplayString ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/27/2015 09:08'!
spotterForRepositoriesFor: aStep
	<spotterOrder: 87>
	aStep listProcessor
		title: 'Monticello Repositories';
		allCandidates: [ MCRepositoryGroup default repositories ];
		itemIcon: #systemIcon;
		wantsToDisplayOnEmptyQuery: false;
		filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/19/2016 18:01'!
spotterForSendersFor: aStep
	<spotterOrder: 31>

	aStep listProcessor
		title: 'Senders';
		filter: GTNullFilter item: [ :filter :context | 
			SystemNavigation default
				allSendersToString: context textTrimmed 
				do: filter ];
		keyBinding: $n meta;
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 4/11/2015 22:18'!
spotterForStashedPlaygroundPagesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
			allCandidates: [ 
				| stashFiles |
				stashFiles := GTPlayBook stashDirectory files 
					select: [ :each | each extension = GTPlayPage fileExtension ].
				stashFiles collect: [ :file |
					(GTPlayPage fromFileReference: file) 
						title: (file basename copyUpTo: $-) ] ];
			title: 'Playground named pages';
			itemName: [ :page | page title, ' - ', page content asString contractTo: 100 ];
			filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 4/10/2015 13:23'!
spotterHistoryFor: aStep
	<spotterOrder: 8>
	aStep listProcessor
			allCandidates: [ self history asArray select: [ :each | each isNotNil and: [ each value isNotNil ] ] ];
			title: 'History';
			itemName: [ :item | 
				item class = GTSpotterProcessorLink 
					ifTrue: [ item processor itemNameFor: item value ] " HACK: this triggers a recursion !! ... but processor is undefined for aCandidate "
					ifFalse: [ item gtDisplayString ] ];
			filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/19/2016 18:01'!
spotterImplementorsFor: aStep
	<spotterOrder: 30>
	self flag: #specialFilter.
	aStep listProcessor
		title: 'Implementors';
		filter: GTFilterImplementor item: [ :filter :context | 
			SystemNavigation default allBehaviorsDo: [ :class | class methodsDo: filter ] ];
		keyBinding: $m meta;
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:39'!
spotterStfxFor: aStep
	<spotterOrder: 30>
	self flag: #specialFilter.
	^ aStep listProcessor
		title: 'ws.stfx.eu';
		filter: GTNullFilter item: [ :filter :context | 
			(context textTrimmed beginsWith: 'http://ws.stfx.eu')
				ifTrue: [ GTPlayPage loadFromPublishUrl: context textTrimmed thenDo: filter ] ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 10/14/2015 21:57'!
spotterWorldMenuFor: aStep
	<spotterOrder: 9>
	
	^ (World worldMenu spotterItemsFor: aStep)
		candidatesLimit: 15;
		allCandidates: [ World worldMenu allItems ];
		title: 'Menu'! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/18/2014 23:22'!
spotterActDefault
	^ self browse! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 12/1/2015 12:05'!
spotterForBytecodesFor: aStep
	<spotterOrder: 15>
	aStep listProcessor
		title: 'Bytecode';
		allCandidates: [ self symbolicBytecodes ];
		itemName: #printString;
		filter: GTFilterSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/14/2016 19:31'!
spotterForImplementorsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Implementors';
			allCandidates: [ self implementors collect: #compiledMethod ];
			filter: GTFilterSubstring;
			keyBinding: $m command! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/22/2016 17:38'!
spotterForMessagesFor: aStep
	<spotterOrder: 12>
	aStep listProcessor
			title: 'Messages';
			allCandidates: [ self messages asSortedCollection collect: [:each | GTSelector new name: each ] ];
			filter: GTFilterSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/21/2016 19:26'!
spotterForSendersFor: aStep
	<spotterOrder: 11>
	aStep listProcessor
			title: 'Senders';
			allCandidates: [ self senders collect: #compiledMethod ];
			filter: GTFilterSubstring;
			keyBinding: $n command! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/20/2014 23:13'!
spotterItemsFor: aStep
	"do nothing for compiled method"! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 6/15/2015 00:32'!
spotterMethodClassFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			allCandidates: [  {self methodClass }];
			title: 'Class';
			filter: GTFilterSubstring;
			itemIcon: #systemIcon! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/13/2015 18:19'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: [ self gtDisplayString ];
		display: [:compiledMethod | 
			' ', compiledMethod getSource];
		smalltalkClass: [self methodClass];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/23/2015 00:56'!
spotterSelectFor: aStep
	" ignore :) "! !

!MCVersionInfo class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleVersionInfo
	<gtExample>
	<label: 'Metacello version-info'>
	
	MCWorkingCopy allManagers do: [ :each | 
		each packageName = 'GT-SpotterExtensions-Core' ifTrue: [ 
			^ each versionInfo ] ].
	^ nil! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/27/2015 09:59'!
allAncestors
	^ (self allAncestorsTo: OrderedCollection new)
		sort: [ :a :b | a timeStamp >= b timeStamp ]! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/27/2015 10:02'!
allAncestorsTo: aCollection
	self ancestors do: [ :versionInfo | 
		" do not add/process ancestry-branches which have already been added/processed "
		(aCollection includes: versionInfo) ifFalse: [ 
			aCollection add: versionInfo.
			versionInfo allAncestorsTo: aCollection ] ].
	^ aCollection! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 16:54'!
gtDisplayOn: stream
	stream nextPutAll: self name! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/26/2015 15:03'!
"protocol: *GT-SpotterExtensions-Core"
spotterAncestorsFor: aStep
	<spotterOrder: 1>
	self flag: 'rewrite for direct streaming - get rid of recursion'.
	aStep listProcessor
		title: 'Ancestors';
		allCandidates: [ self allAncestors ];
		filter: GTFilterSubstring! !

!RBClassEnvironment methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 3/23/2015 13:12'!
withClassesFixedForNautilus
	classes ifEmpty: [ 
		metaClasses do: [ :each | 
			classes add: each ] ]! !

!SettingTree class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:26'!
gtExampleSettingTree
	<gtExample>
	<label: 'Settings tree'>
	
	^ SettingTree new acceptableKeywords: SettingBrowser settingsKeywords! !

!SettingTree methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/12/2015 16:56'!
spotterForSettingsFor: aStep
	<spotterOrder: 0>
	aStep listProcessor
		title: 'Settings';
		allCandidates: [ self nodeList ];
		itemName: [ :each | each spotterLabel ];
		filter: GTFilterSubstring! !

!KMDispatcher methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 12/4/2015 11:23'!
spotterForKeysFor: aStep
	<spotterOrder: 15>
		
	aStep listProcessor
			title: 'Keys';
			allCandidates: [ (self gtAllKeyCategoryPairs collect: #key) asOrderedCollection ];
			itemName: [ :aKeymap | 
				aKeymap shortcut gtDisplayString, 
				(aKeymap name ifNil: [ '' ] ifNotNil: [ ' [', aKeymap name,']' ]) ];
			candidatesLimit: 5;
			filter: GTFilterSubstrings! !

!MCWorkingCopy class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'MarcusDenker 6/8/2016 15:41'!
gtExampleWorkingCopy
	<gtExample>
	<label: 'Metacello working-copy'>
	
	^ (RPackageOrganizer default packageOf: GTSpotter) mcPackage 
		ifNotNil: [ :mcp | mcp workingCopy ]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'MarcusDenker 6/8/2016 15:40'!
allAncestors
	^ self versionInfo 
		ifNotNil: [ :versionInfo | versionInfo allAncestors ]
		ifNil: [ #() ]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 17:01'!
gtDisplayOn: stream
	ancestry ancestors isEmpty 
		ifTrue: [ 
			super gtDisplayOn: stream. stream nextPutAll: ' (unsaved)' ]
		ifFalse: [ 
			ancestry ancestors first gtDisplayOn: stream.
			self needsSaving ifTrue: [ stream nextPutAll: ' (modified)' ] ]
		! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'MarcusDenker 6/8/2016 15:40'!
nextAncestors
	^ self versionInfo 
		ifNotNil: [ :versionInfo | versionInfo ancestors ]
		ifNil: [ #() ]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 3/22/2016 23:21'!
spotterAllRepositoriesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
		title: 'All other repositories';
		allCandidates: [ MCRepositoryGroup default repositories \ self repositoryGroup repositories ];
		itemName: [ :item | item description ];
		actLogic: [ :item :step | 
			step exit.
			self spotterCommit: self in: item ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/26/2015 15:55'!
spotterAncestorsFor: aStep
	<spotterOrder: 2>
	self flag: #maybeRewriteForDirectStreaming.
	aStep listProcessor
		title: 'Ancestors';
		allCandidates: [ self allAncestors ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/3/2014 07:34'!
spotterCommit: workingCopy in: aRepository
	| newVersion |

	newVersion := workingCopy newVersionIn: aRepository.
	newVersion ifNil: [ ^ self ].
	Cursor wait showWhile: [
		[ 	aRepository storeVersion: newVersion.
			aRepository storeDependencies: newVersion ] 
		ensure: [ (MCVersionInspector new version: newVersion) show ]]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterMonticelloPackageFor: aStep
	<spotterOrder: 21>
	aStep listProcessor
		title: 'Monticello Package';
		allCandidates: [ Array with: self package ];
		itemIcon: [ Smalltalk ui icons iconNamed: #monticelloPackageIcon ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'MarcusDenker 6/8/2016 15:40'!
spotterPackageFor: aStep
	<spotterOrder: 21>
	self flag: #maybeRewriteForDirectStreaming.
	aStep listProcessor
		title: 'Packages';
		allCandidates: [ self package correspondingRPackage 
			ifNotNil: [ :rpackage | { rpackage } ] 
			ifNil: [ { } ] ];
		itemName: [ :item | item name ];
		itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 3/22/2016 23:21'!
spotterPackageRepositoriesFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
		title: 'Package repositories';
		allCandidates: [ self repositoryGroup repositories ];
		itemName: [ :item | item description ];
		actLogic: [ :item :step |
			step exit.
			self spotterCommit: self in: item ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'MarcusDenker 8/20/2015 15:56'!
versionInfo
	^ self ancestors 
		ifNotEmpty: [ :list | list first ] 
		ifEmpty: [ nil ]! !

!SystemNavigation methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 1/11/2016 18:57'!
allReferencesTo: aLiteral do: aBlock
	| symbol |
	symbol := aLiteral isSymbol.
	self allBehaviorsDo: [ :class |
		symbol
			ifFalse: [ class withMethodsReferTo: aLiteral do: aBlock ]
			ifTrue: [ class withThorougMethodsReferTo: aLiteral do: aBlock ] ]! !

!SystemNavigation methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'TudorGirba 1/12/2016 00:52'!
allReferencesToSubstring: aString do: aBlock
	| sortedClasses |
	aString isEmptyOrNil ifTrue: [ ^ self ].
	sortedClasses := SortedCollection new sortBlock: [ :a :b | a name size < b name size ].
	(self allBehaviorsDo: [ :class |
		(class name includesSubstring: aString caseSensitive: false) ifTrue: [ 
			sortedClasses add: class ] ]).
	sortedClasses do: [ :class |
		self allReferencesTo: class binding do: aBlock ]! !

!SystemNavigation methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'TudorGirba 1/19/2016 13:46'!
allSendersToString: aString do: aBlock
	aString isEmptyOrNil ifTrue: [ ^ self ].
	aString asSymbol ifNotNil: [ :symbol |
		self allBehaviorsDo: [ :class | 
			class withMethodSender: symbol do: aBlock ] ]! !

!Text methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/23/2015 09:23'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	^ aComposite text
		title: 'Contents';
		display: [ :item | item asString contractTo: 100 ];
		entity: self! !

!Clipboard methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 3/25/2015 08:40'!
recentItems
	recent isEmptyOrNil ifTrue: [ ^ #() ].
	^ recent allButFirst reject: [ :each | 
		each isEmptyOrNil 
			or: [ each asString trimBoth isEmptyOrNil ] ]! !

!RBSelectorEnvironment methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 3/23/2015 13:12'!
withClassesFixedForNautilus
	classSelectors ifEmpty: [ 
		metaClassSelectors keysAndValuesDo: [ :class :selectors | 
			classSelectors at: class ifAbsentPut: [ IdentitySet new ] ] ]! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/5/2015 00:33'!
spotterActDefault
	^ self browse! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterClassMethodsFor: aStep
	<spotterOrder: 15>
	aStep listProcessor
			title: 'Class methods';
			allCandidates: [ self classSide methods ];
			itemName: [ :method | method selector ];
			filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterMethodsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Instance methods';
			allCandidates: [ self methods ];
			itemName: [ :method | method selector ];
			filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:04'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: [self name];
		display: #definitionForNautilus;
		smalltalkClass: [ nil ];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterReferenceFor: aStep
	<spotterOrder: 30>
	aStep listProcessor
			title: 'References';
			allCandidates: [ (SystemNavigation default allReferencesTo: self binding) collect: #compiledMethod ];
			itemName: [ :method | method gtDisplayString ];
			filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 3/22/2015 15:42'!
spotterSuperClassMethodsFor: aStep
	<spotterOrder: 16>
	|superclasses|
	superclasses := self class withAllSuperclasses select: #isMeta.
	aStep listProcessor
			title: 'Super class methods';
			allCandidates: [ self classSide allMethods select: [ :each |(each methodClass = self classSide) not & (superclasses includes: each methodClass) ] ];
			filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterSuperMethodsFor: aStep
	<spotterOrder: 11>
	aStep listProcessor
			title: 'Super instance methods';
			allCandidates: [ self allMethods reject: [ :each | each methodClass = self ] ];
			filter: GTFilterSubstring! !

!MenuMorph class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 4/4/2016 10:51'!
gtExampleMenuMorph
	<gtExample>
	| menu |
	menu := MenuMorph new.
	menu buildTitle: [ :menuTitle | menuTitle
		onlyCloseAndPinable
	].
	menu add: 'apples' selector: #apples.
	menu add: 'oranges' selector: #oranges.
	menu addLine.
	menu add: 'peaches' selector: #peaches.
	menu addLine.
	menu add: 'pears' selector: #pears.
	menu addLine.
	^ menu
	! !

!MenuMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/22/2014 17:33'!
allItems
	| all |
	all := OrderedCollection new.
	self items do: [ :each |
		all add: each.
		each hasSubMenu 
			ifTrue: [ all addAll: each subMenu allItems ] ].
	^ all! !

!MenuMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 3/22/2016 23:21'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	self flag: #refactoringViolationForSpotterActDefault:.
	^ aStep listProcessor 
		title: 'Items';
		candidatesLimit: Float infinity;
		allCandidates: [ self items ];
		itemName: #contents;
		itemIcon: [ :item | item icon ];
		actLogic: [ :item :step | 
			item hasSubMenu 
				ifTrue: [ step diveIn ] 
				ifFalse: [ item spotterActDefault. step exit ] ];
		filter: GTFilterSubstring ! !

!GTInspector class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 7/10/2015 15:41'!
spotterExtensionsFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			allCandidates: [ self inspectorExtendingMethods ];
			title: 'Extensions';
			itemName:[ :each | each gtDisplayString ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: true! !

!AbstractCompiler methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/23/2015 16:34'!
silentlyDo: aBlock
	self silentlyDo: aBlock exceptionDo: [ " ignore " ]! !

!AbstractCompiler methodsFor: '*GT-SpotterExtensions-Core' stamp: 'MarcusDenker 8/20/2015 11:13'!
silentlyDo: aBlock1 exceptionDo: aBlock2
	aBlock1
		on: Error, SyntaxErrorNotification, OCSemanticWarning, OCSemanticError
		do: aBlock2! !

!RGMethodDefinition methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 7/10/2015 15:37'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: [ self gtDisplayString ];
		display: [ :methodDefinition | 
			' ', methodDefinition sourceCode];
		smalltalkClass: [self methodClass];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 14:11'!
gtAllSubtopics
	 ^ self subtopics flatCollect: [:aTopic |
		aTopic asOrderedCollection, aTopic gtAllSubtopics ]
		 ! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 14:38'!
gtBreadcrumbTitle
	|breadcrumbTitle currentHelpTopic|
	
	currentHelpTopic := self.	
	breadcrumbTitle:= currentHelpTopic title.
	[ currentHelpTopic owner notNil and: [currentHelpTopic owner owner notNil ] ] whileTrue: [ 
		currentHelpTopic := currentHelpTopic owner.
		breadcrumbTitle := breadcrumbTitle , ' > ', currentHelpTopic title  ].
	^ breadcrumbTitle ! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TorstenBergmann 8/11/2015 19:12'!
gtTopicIcon
	^self hasSubtopics 
			ifTrue: [ Smalltalk ui icons bookIcon ] 
	    	ifFalse: [ Smalltalk ui icons pageIcon ]! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 4/16/2015 08:52'!
spotterActDefault
	HelpBrowser openOn: self! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:40'!
spotterForHelpTopicFor: aStep
	<spotterOrder: 200>
	self flag: 'filter for multiple items like #title + #contents (combined by OR)'.
	self flag: #specialFilter.
	aStep listProcessor 
		title: 'Help contents';
		items: [ self subtopics ];
		itemName: [ :helpTopic | helpTopic title ];
		itemIcon: [ :helpTopic | helpTopic gtTopicIcon ];
		itemFilterName: [ :helpTopic | helpTopic contents asString ]; " the filter should only scan the contents / maybe title too ? "
		filter: GTFilterSubstrings;
		wantsToDisplayOnEmptyQuery: true! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 12:58'!
spotterPreviewContentHelpIn: aComposite
	<spotterPreview: 10>
	
	self hasSubtopics ifTrue: [ ^ self ].
	aComposite text
		title: [ self title ];
		display: [:aHelpTopic | 
			aHelpTopic contents];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 14:31'!
spotterPreviewSubtopicsHelpIn: aComposite
	<spotterPreview: 15>

	aComposite list
		title: [ self title ];
		display: #yourself;
		format: [ :aHelpTopic | GTSpotterItemBrick new 
				text: aHelpTopic title;
				icon: aHelpTopic gtTopicIcon;
				disable ];
		styled: [ :brick | brick ];
		entity: self subtopics.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!BlockClosure methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 12/1/2015 17:50'!
gtSpotterCodePreviewIn: aComposite
	<spotterPreview: 10>

	^ self sourceNode gtSpotterCodePreviewIn: aComposite! !

!SettingNode class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:26'!
gtExampleSettingNode
	<gtExample>
	<label: 'Settings node'>
	
	^ SettingTree gtExampleSettingTree nodeList anyOne! !

!SettingNode methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/13/2015 22:02'!
spotterForSettingsFor: aStep
	<spotterOrder: 0>
	self allChildren isEmpty ifTrue: [ ^ self ].
	aStep listProcessor
		title: 'Children';
		allCandidates: [ self allChildren ];
		itemName: [ :each | each spotterLabel ];
		filter: GTFilterSubstring! !

!SettingNode methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/12/2015 16:57'!
spotterLabel
	| label |
	label := self settingDeclaration label.
	^ self parentNode isNil
		ifTrue: [ label ]
		ifFalse: [ self parentNode spotterLabel , '/', label ]
		! !

!SettingNode methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/20/2015 10:06'!
spotterPreviewIn: composite
	<spotterPreview: 0>
	
	composite custom: (
				(self settingDeclaration inputWidget asBrick)
						hSpaceFill;
						vShrinkWrap;
						vAlign: #center;
						yourself)! !

!Pragma methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/15/2014 00:01'!
spotterActDefault
    ^ self method browse! !

!Pragma methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 2/23/2016 18:19'!
spotterForBytecodesFor: aStep
	<spotterOrder: 15>
	self method spotterForBytecodesFor: aStep! !

!Pragma methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 2/23/2016 18:19'!
spotterForImplementorsFor: aStep
	<spotterOrder: 10>
	self method spotterForImplementorsFor: aStep! !

!Pragma methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 2/23/2016 18:19'!
spotterForSendersFor: aStep
	<spotterOrder: 10>
	self method spotterForSendersFor: aStep! !

!Pragma methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/13/2015 18:19'!
spotterPreviewIn: composite
	<spotterPreview: 10>
   self method spotterPreviewCodeIn: composite! !

!ThemeIcons class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 10/10/2015 20:22'!
gtExampleThemeIcons
	<gtExample>
	<label: 'Icon Theme'>
	^ Smalltalk ui icons! !

!Collection methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/31/2015 10:47'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	| processor |
	self ifEmpty: [ ^ self ].
	processor := aStep previousProcessorFrom: self.
	^ aStep listProcessor
		title: processor title;
		candidatesLimit: 100;
		items: [ self collect: [ :each | each asSpotterCandidateLink value] as: OrderedCollection ];
		itemName: processor itemName;
		itemIcon: processor itemIcon;
		actLogic: processor actLogic;
		itemFilterName: processor itemFilterName;
		filter: processor filter gtListFilter;
		wantsToDisplayOnEmptyQuery: true! !

!MetacelloProject class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleMetacelloProject
	<gtExample>
	<label: 'Metacello project'>
	
	^ ConfigurationOfGTSpotter project! !

!MetacelloProject methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/26/2015 15:55'!
spotterForVersionsFor: aStep
	<spotterOrder: 1>
	self flag: #maybeRewriteForDirectStreaming.
	aStep listProcessor
		title: 'Versions';
		allCandidates: [
			(#( stableVersion currentVersion bleedingEdge development ) 
				collect: [ :each | [ self perform: each ] on: Error do: [  nil ] ]) 
				reject: [ :each | each isNil ] ];
		itemName: [ :version | version versionString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !
